unit ControlFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleServer, CmAdmCtl;

type
  TForm1 = class(TForm)
    COMAdmin: TCOMAdminCatalog;
    ListBox1: TListBox;
    PopulateBtn: TButton;
    RunningBtn: TButton;
    StopBtn: TButton;
    StartBtn: TButton;
    RemoveBtn: TButton;
    InstallBtn: TButton;
    Label1: TLabel;
    CloseBtn: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    procedure PopulateBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RunningBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure RemoveBtnClick(Sender: TObject);
    procedure InstallBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     Apps, App : TCOMAdminCatalogCollection;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.PopulateBtnClick(Sender: TObject);
Var
  I: Integer;
begin
    ListBox1.Items.Clear;
    Apps := COMAdmin.GetCollection('Applications');
    Apps.Populate;
    for I := 0 to Pred(Apps.Count) do    // Iterate
        begin
        ListBox1.Items.Add(Apps.Get_Item(i).Name)
        end;    // for
    RunningBtn.Enabled := True;
    StopBtn.Enabled := True;
    StartBtn.Enabled := True;
    RemoveBtn.Enabled := True;
    InstallBtn.Enabled := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
COMAdmin.Connect;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
COMAdmin.DisConnect;
end;

procedure TForm1.RunningBtnClick(Sender: TObject);
Var
  ObjectKey : OleVariant;
  AppName : String;
begin
  ObjectKey := Apps.get_Item(ListBox1.ItemIndex).Get_Key;
  AppName :=  'ApplicationInstances';
  //exit;
  App := Apps.GetCollection(AppName,ObjectKey);
  App.Populate;
  if App.count > 0 then
     Label1.Caption := ListBox1.Items[ListBox1.itemIndex] + ' is running'
  else
     Label1.Caption := ListBox1.Items[ListBox1.itemIndex] + ' is not running'
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
ComAdmin.ShutdownApplication(ListBox1.Items[ListBox1.itemIndex]);
RunningBtn.Click;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
begin
ComAdmin.StartApplication(ListBox1.Items[ListBox1.itemIndex]);
RunningBtn.Click;
end;

procedure TForm1.CloseBtnClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.RemoveBtnClick(Sender: TObject);
begin
Apps.Remove(ListBox1.ItemIndex);
Apps.SaveChanges;
end;

procedure TForm1.InstallBtnClick(Sender: TObject);
Var
  NewFileName : String;
begin
if OpenDialog1.Execute then
   begin
   NewFileName := OpenDialog1.FileName;
   Edit1.Text := NewFileName;
   COMAdmin.InstallApplication(NewFileName,'',2,'Mts_User','porkpie','');
   PopulateBtn.Click;
   ShowMessage('Installed');
   end;
end;

end.
